Index: branches/new_class_id/src/world_entities/skysphere.cc
===================================================================
--- branches/new_class_id/src/world_entities/skysphere.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/skysphere.cc	(revision 9709)
@@ -27,5 +27,4 @@
 
 #include "skysphere.h"
-#include "stdincl.h"
 
 #include "material.h"
@@ -33,5 +32,5 @@
 
 
-
+NewObjectListDefinition(Skysphere);
 
 /**
@@ -41,5 +40,5 @@
 Skysphere::Skysphere(char* fileName)
 {
-  this->setClassID(CL_SKYSPHERE, "SkySphere");
+  this->registerObject(this, Skysphere::_objectList);
   this->toList(OM_BACKGROUND);
   if (fileName == NULL)
Index: branches/new_class_id/src/world_entities/skysphere.h
===================================================================
--- branches/new_class_id/src/world_entities/skysphere.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/skysphere.h	(revision 9709)
@@ -24,4 +24,5 @@
 class Skysphere : public WorldEntity
 {
+  NewObjectListDeclaration(Skysphere);
 
  public:
Index: branches/new_class_id/src/world_entities/space_ships/collision_probe.cc
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/collision_probe.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/collision_probe.cc	(revision 9709)
@@ -24,7 +24,8 @@
 
 
+#include "class_id.h"
+NewObjectListDefinitionID(CollisionProbe, CL_COLLISION_PROBE);
 
-
-CREATE_FACTORY(CollisionProbe, CL_COLLISION_PROBE);
+CREATE_FACTORY(CollisionProbe);
 
 
@@ -56,5 +57,5 @@
 void CollisionProbe::init()
 {
-  this->setClassID(CL_COLLISION_PROBE, "CollisionProbe");
+  this->registerObject(this, CollisionProbe::_objectList);
 
   bUp = bDown = bLeft = bRight = bAscend = bDescend = bRollL = bRollR = false;
Index: branches/new_class_id/src/world_entities/space_ships/collision_probe.h
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/collision_probe.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/collision_probe.h	(revision 9709)
@@ -13,4 +13,5 @@
 class CollisionProbe : public Playable
 {
+  NewObjectListDeclaration(CollisionProbe);
 
   public:
Index: branches/new_class_id/src/world_entities/space_ships/cruizer.cc
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/cruizer.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/cruizer.cc	(revision 9709)
@@ -34,5 +34,7 @@
 #include "debug.h"
 
-CREATE_FACTORY(Cruizer, CL_CRUIZER);
+#include "class_id.h"
+NewObjectListDefinitionID(Cruizer, CL_CRUIZER);
+CREATE_FACTORY(Cruizer);
 
 /**
@@ -89,5 +91,5 @@
 {
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_CRUIZER, "Cruizer");
+  this->registerObject(this, Cruizer::_objectList);
 
   this->setSupportedPlaymodes(Playable::Full3D);
Index: branches/new_class_id/src/world_entities/space_ships/cruizer.h
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/cruizer.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/cruizer.h	(revision 9709)
@@ -16,4 +16,5 @@
 class Cruizer : public Playable
 {
+  NewObjectListDeclaration(Cruizer);
   public:
     Cruizer(const std::string& fileName);
Index: branches/new_class_id/src/world_entities/space_ships/helicopter.cc
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/helicopter.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/helicopter.cc	(revision 9709)
@@ -34,7 +34,9 @@
 #include "debug.h"
 
-CREATE_FACTORY(Helicopter, CL_HELICOPTER);
+#include "class_id.h"
+NewObjectListDefinitionID(Helicopter, CL_HELICOPTER);
+CREATE_FACTORY(Helicopter);
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(Helicopter, CL_HELICOPTER,
+CREATE_SCRIPTABLE_CLASS(Helicopter, Helicopter::classID(),
                         addMethod("moveUp", ExecutorLua1<Helicopter,bool>(&Helicopter::moveUp))
                             ->addMethod("moveDown", ExecutorLua1<Helicopter,bool>(&Helicopter::moveDown))
@@ -46,4 +48,5 @@
                        );
 
+
 /**
  *  creates the controlable Helicopter
@@ -100,5 +103,5 @@
   Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_CANNON));
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate("Cannon"));
 
   cannon->setName("BFG");
@@ -126,5 +129,5 @@
   this->chopperBuffer = NULL;
 
-  this->setClassID(CL_HELICOPTER, "Helicopter");
+  this->registerObject(this, Helicopter::_objectList);
   PRINTF(4)("HELICOPTER INIT\n");
 
Index: branches/new_class_id/src/world_entities/space_ships/helicopter.h
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/helicopter.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/helicopter.h	(revision 9709)
@@ -17,4 +17,5 @@
 class Helicopter : public Playable
 {
+  NewObjectListDeclaration(Helicopter);
 
   public:
Index: branches/new_class_id/src/world_entities/space_ships/hover.cc
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/hover.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/hover.cc	(revision 9709)
@@ -34,8 +34,10 @@
 #include "debug.h"
 
-CREATE_FACTORY(Hover, CL_HOVER);
+#include "class_id.h"
+NewObjectListDefinitionID(Hover, CL_HOVER);
+CREATE_FACTORY(Hover);
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(Hover, CL_HOVER,
+CREATE_SCRIPTABLE_CLASS(Hover, Hover::classID(),
                         addMethod("hasPlayer", ExecutorLua0ret<Playable,bool>(&Playable::hasPlayer))
                         //Coordinates
@@ -98,5 +100,5 @@
   Weapon* wpLeft = new TestGun(1);
   wpLeft->setName("testGun Left");
-  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate(CL_HYPERBLASTER));
+  Weapon* cannon = dynamic_cast<Weapon*>(Factory::fabricate("Hyperblaster"));
 
   cannon->setName("BFG");
@@ -123,5 +125,5 @@
 
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_HOVER, "Hover");
+  this->registerObject(this, Hover::_objectList);
   this->toReflectionList();
 
Index: branches/new_class_id/src/world_entities/space_ships/hover.h
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/hover.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/hover.h	(revision 9709)
@@ -15,4 +15,5 @@
 class Hover : public Playable
 {
+  NewObjectListDeclaration(Hover);
   public:
 
Index: branches/new_class_id/src/world_entities/space_ships/space_ship.cc
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/space_ship.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/space_ship.cc	(revision 9709)
@@ -53,8 +53,10 @@
 
 
-
-CREATE_FACTORY(SpaceShip, CL_SPACE_SHIP);
+#include "class_id.h"
+NewObjectListDefinitionID(SpaceShip, CL_SPACE_SHIP);
+CREATE_FACTORY(SpaceShip);
+
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(SpaceShip, CL_SPACE_SHIP,
+CREATE_SCRIPTABLE_CLASS(SpaceShip, SpaceShip::classID(),
                         addMethod("hasPlayer", ExecutorLua0ret<Playable,bool>(&Playable::hasPlayer))
                         ->addMethod("fire", ExecutorLua1<Playable, bool>(&Playable::fire))
@@ -117,5 +119,5 @@
 {
 //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_SPACE_SHIP, "SpaceShip");
+  this->registerObject(this, SpaceShip::_objectList);
 
   PRINTF(4)("SPACESHIP INIT\n");
Index: branches/new_class_id/src/world_entities/space_ships/space_ship.h
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/space_ship.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/space_ship.h	(revision 9709)
@@ -19,4 +19,5 @@
 class SpaceShip : public Playable
 {
+  NewObjectListDeclaration(SpaceShip);
 
   public:
@@ -36,5 +37,5 @@
     virtual void postSpawn();
     virtual void leftWorld();
-    
+
     virtual void destroy(WorldEntity* killer);
     virtual void respawn();
Index: branches/new_class_id/src/world_entities/space_ships/spacecraft_2d.cc
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/spacecraft_2d.cc	(revision 9709)
@@ -38,8 +38,9 @@
 
 
-CREATE_FACTORY(Spacecraft2D, CL_SPACECRAFT_2D);
-
-
-CREATE_SCRIPTABLE_CLASS(Spacecraft2D, CL_SPACECRAFT_2D,
+#include "class_id.h"
+NewObjectListDefinitionID(Spacecraft2D, CL_SPACECRAFT_2D);
+CREATE_FACTORY(Spacecraft2D);
+
+CREATE_SCRIPTABLE_CLASS(Spacecraft2D, Spacecraft2D::classID(),
                         addMethod("hasPlayer", ExecutorLua0ret<Playable,bool>(&Playable::hasPlayer))
                         //Coordinates
@@ -52,4 +53,5 @@
 
 
+
 /**
  * @brief loads a Spacecraft2D information from a specified file.
@@ -85,12 +87,12 @@
 
   //weapons:
-  Weapon* wpRight = dynamic_cast<Weapon*>(Factory::fabricate(CL_LASER_CANNON));
+  Weapon* wpRight = dynamic_cast<Weapon*>(Factory::fabricate("LaserCannon"));
   wpRight->setName("Cannon_Right");
-  Weapon* wpLeft = dynamic_cast<Weapon*>(Factory::fabricate(CL_LASER_CANNON));
+  Weapon* wpLeft = dynamic_cast<Weapon*>(Factory::fabricate("LaserCannon"));
   wpLeft->setName("Cannon_Left");
 
-  Weapon* turretLeft = dynamic_cast<Weapon*>(Factory::fabricate(CL_BOOMERANG_GUN));
+  Weapon* turretLeft = dynamic_cast<Weapon*>(Factory::fabricate("BoomerangGun"));
   wpRight->setName("Turret_Left");
-  Weapon* turretRight = dynamic_cast<Weapon*>(Factory::fabricate(CL_BOOMERANG_GUN));
+  Weapon* turretRight = dynamic_cast<Weapon*>(Factory::fabricate("BoomerangGun"));
   wpLeft->setName("Turret_Right");
 
@@ -125,5 +127,5 @@
 {
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_SPACECRAFT_2D, "Spacecraft2D");
+  this->registerObject(this, Spacecraft2D::_objectList);
 
   this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal );
Index: branches/new_class_id/src/world_entities/space_ships/spacecraft_2d.h
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/spacecraft_2d.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/spacecraft_2d.h	(revision 9709)
@@ -16,4 +16,5 @@
 class Spacecraft2D : public Playable
 {
+  NewObjectListDeclaration(Spacecraft2D);
   public:
     Spacecraft2D(const std::string& fileName);
Index: branches/new_class_id/src/world_entities/space_ships/turbine_hover.cc
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/turbine_hover.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/turbine_hover.cc	(revision 9709)
@@ -34,5 +34,7 @@
 #include "debug.h"
 
-CREATE_FACTORY(TurbineHover, CL_TURBINE_HOVER);
+#include "class_id.h"
+NewObjectListDefinitionID(TurbineHover, CL_TURBINE_HOVER);
+CREATE_FACTORY(TurbineHover);
 
 /**
@@ -101,5 +103,5 @@
 {
   //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_TURBINE_HOVER, "TurbineHover");
+  this->registerObject(this, TurbineHover::_objectList);
 
   this->setSupportedPlaymodes(Playable::Full3D | Playable::Horizontal | Playable::Vertical);
Index: branches/new_class_id/src/world_entities/space_ships/turbine_hover.h
===================================================================
--- branches/new_class_id/src/world_entities/space_ships/turbine_hover.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/space_ships/turbine_hover.h	(revision 9709)
@@ -18,65 +18,66 @@
 class TurbineHover : public Playable
 {
-  public:
-    TurbineHover(const std::string& fileName);
-    TurbineHover(const TiXmlElement* root = NULL);
-    virtual ~TurbineHover();
+  NewObjectListDeclaration(TurbineHover);
+public:
+  TurbineHover(const std::string& fileName);
+  TurbineHover(const TiXmlElement* root = NULL);
+  virtual ~TurbineHover();
 
-    void setBoostColor(const Color& color);
+  void setBoostColor(const Color& color);
 
-    virtual void loadParams(const TiXmlElement* root);
-    virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f);
-    virtual void enter();
-    virtual void leave();
+  virtual void loadParams(const TiXmlElement* root);
+  virtual void setPlayDirection(const Quaternion& rot, float speed = 0.0f);
+  virtual void enter();
+  virtual void leave();
 
-    virtual void setTeam(int teamID);
+  virtual void setTeam(int teamID);
 
-    virtual void postSpawn();
-    virtual void leftWorld();
-    virtual void respawn();
+  virtual void postSpawn();
+  virtual void leftWorld();
+  virtual void respawn();
 
-    virtual void collidesWith(WorldEntity* entity, const Vector& location);
-    virtual void tick(float dt);
-    virtual void draw() const;
+  virtual void collidesWith(WorldEntity* entity, const Vector& location);
+  virtual void tick(float dt);
+  virtual void draw() const;
 
-    virtual void process(const Event &event);
+  virtual void process(const Event &event);
 
-  private:
-    void init();
-    void movement(float dt);
+private:
+  void init();
+  void movement(float dt);
 
-  private:
-    bool                  bForward;           //!< forward button pressed.
-    bool                  bBackward;          //!< backward button pressed.
-    bool                  bLeft;              //!< left button pressed.
-    bool                  bRight;             //!< right button pressed.
-    bool                  bAscend;            //!< ascend button pressed.
-    bool                  bDescend;           //!< descend button presses.
+private:
+  bool                  bForward;           //!< forward button pressed.
+  bool                  bBackward;          //!< backward button pressed.
+  bool                  bLeft;              //!< left button pressed.
+  bool                  bRight;             //!< right button pressed.
+  bool                  bAscend;            //!< ascend button pressed.
+  bool                  bDescend;           //!< descend button presses.
 
-    int                   yInvert;
-    float                 mouseSensitivity;   //!< the mouse sensitivity
+  int                   yInvert;
+  float                 mouseSensitivity;   //!< the mouse sensitivity
 
-    PNode                 wingNodeLeft;
-    PNode                 wingNodeRight;
-    PNode                 rotorNodeLeft;
-    PNode                 rotorNodeRight;
+  PNode                 wingNodeLeft;
+  PNode                 wingNodeRight;
+  PNode                 rotorNodeLeft;
+  PNode                 rotorNodeRight;
 
-    PNode                 cameraNode;
-    float                 cameraLook;
-    float                 rotation;
+  PNode                 cameraNode;
+  float                 cameraLook;
+  float                 rotation;
 
-   // Vector                velocity;           //!< the velocity of the TurbineHover.
-    Quaternion            direction;          //!< the direction of the TurbineHover.
-    float                 travelSpeed;        //!< the current speed of the Hove (to make soft movement)
-    float                 acceleration;       //!< the acceleration of the TurbineHover.
-    float                 airFriction;        //!< AirFriction.
+  // Vector                velocity;           //!< the velocity of the TurbineHover.
+  Quaternion            direction;          //!< the direction of the TurbineHover.
+  float                 travelSpeed;        //!< the current speed of the Hove (to make soft movement)
+  float                 acceleration;       //!< the acceleration of the TurbineHover.
+  float                 airFriction;        //!< AirFriction.
 
-    float                 rotorSpeed;         //!< the speed of the rotor.
-    float                 rotorCycle;         //!< The Cycle the rotor is in.
+  float                 rotorSpeed;         //!< the speed of the rotor.
+  float                 rotorCycle;         //!< The Cycle the rotor is in.
 
-    float                 airViscosity;
+  float                 airViscosity;
 
-    ParticleEmitter*      burstEmitter[2];
-    ParticleSystem*       burstSystem;
+  ParticleEmitter*      burstEmitter[2];
+  ParticleSystem*       burstSystem;
 };
 
Index: branches/new_class_id/src/world_entities/spawning_point.cc
===================================================================
--- branches/new_class_id/src/world_entities/spawning_point.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/spawning_point.cc	(revision 9709)
@@ -34,6 +34,6 @@
 
 #include "class_id.h"
-CREATE_FACTORY( SpawningPoint, CL_SPAWNING_POINT );
 NewObjectListDefinitionID(SpawningPoint, CL_SPAWNING_POINT);
+CREATE_FACTORY( SpawningPoint);
 /**
  *  constructor
Index: branches/new_class_id/src/world_entities/spectator.cc
===================================================================
--- branches/new_class_id/src/world_entities/spectator.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/spectator.cc	(revision 9709)
@@ -22,8 +22,7 @@
 #include "shared_network_data.h"
 
-CREATE_FACTORY(Spectator, CL_SPECTATOR);
-
-
-
+#include "class_id.h"
+NewObjectListDefinitionID(Spectator, CL_SPECTATOR);
+CREATE_FACTORY(Spectator);
 
 
@@ -58,5 +57,5 @@
 {
 //  this->setRelDir(Quaternion(M_PI, Vector(1,0,0)));
-  this->setClassID(CL_SPECTATOR, "Spectator");
+  this->registerObject(this, Spectator::_objectList);
 
   this->getWeaponManager().changeWeaponConfig(1);
@@ -89,5 +88,5 @@
   dynamic_cast<Element2D*>(this->getWeaponManager().getFixedTarget())->setVisibility( false);
 
- 
+
   registerVar( new SynchronizeableBool( &bLeft, &bLeft, "bLeft", PERMISSION_OWNER ) );
   registerVar( new SynchronizeableBool( &bRight, &bRight, "bRight", PERMISSION_OWNER ) );
@@ -161,50 +160,50 @@
 {
   Playable::tick( time );
-  
+
   if( ( xMouse != 0 || yMouse != 0 ) && this->getOwner() == SharedNetworkData::getInstance()->getHostID() )
   {
     xMouse *= time / 10;
     yMouse *= time / 10;
-    
+
     angleX -= xMouse;
     angleY -= yMouse;
-    
+
     if ( angleY > 2.05 )
       angleY = 2.05;
-    
+
     if ( angleY < -1.15 )
       angleY = -1.15;
-    
+
     this->mouseDir = Quaternion( angleX, Vector( 0, 1, 0 ) ) * Quaternion( angleY, Vector( 0, 0, 1 ) );
-    
+
     xMouse = yMouse = 0;
   }
-  
+
   this->setAbsDir( this->mouseDir );
-  
+
   Vector velocity;
-  
+
   if ( this->bForward )
   {
     velocity += this->getAbsDirX();
   }
-  
+
   if ( this->bBackward )
   {
     velocity -= this->getAbsDirX();
   }
-  
+
   if ( this->bRight )
   {
     velocity += this->getAbsDirZ();
   }
-  
+
   if ( this->bLeft )
   {
     velocity -= this->getAbsDirZ();
   }
-  
+
   velocity *= 100;
-  
+
   this->shiftCoor( velocity*time );
 }
Index: branches/new_class_id/src/world_entities/spectator.h
===================================================================
--- branches/new_class_id/src/world_entities/spectator.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/spectator.h	(revision 9709)
@@ -11,4 +11,5 @@
 class Spectator : public Playable
 {
+  NewObjectListDeclaration(Spectator);
 
   public:
@@ -37,5 +38,5 @@
     bool                  bForward;
     bool                  bBackward;
-    
+
     float                 xMouse;             //!< mouse moved in x-Direction
     float                 yMouse;             //!< mouse moved in y-Direction
Index: branches/new_class_id/src/world_entities/terrain.cc
===================================================================
--- branches/new_class_id/src/world_entities/terrain.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/terrain.cc	(revision 9709)
@@ -34,6 +34,7 @@
 
 
-
-CREATE_FACTORY(Terrain, CL_TERRAIN);
+#include "class_id.h"
+NewObjectListDefinitionID(Terrain, CL_TERRAIN);
+CREATE_FACTORY(Terrain);
 
 /**
@@ -89,5 +90,5 @@
 {
   if (objectList)
-    glDeleteLists(this->objectList, 1);
+    glDeleteLists(this->modelList, 1);
   if( this->ssp)
     delete ssp;
@@ -104,9 +105,9 @@
 void Terrain::init()
 {
-  this->setClassID(CL_TERRAIN, "Terrain");
+  this->registerObject(this, Terrain::_objectList);
   this->toList(OM_ENVIRON_NOTICK);
   this->toReflectionList();
 
-  this->objectList = 0;
+  this->modelList = 0;
   this->ssp = NULL;
   this->vegetation = NULL;
@@ -207,5 +208,5 @@
 
   if (this->objectList)
-    glCallList(this->objectList);
+    glCallList(this->modelList);
   else if (this->getModel())
     this->getModel()->draw();
@@ -256,6 +257,6 @@
   if (debugTerrain == TERRAIN_DAVE)
   {
-    objectList = glGenLists(1);
-    glNewList (objectList, GL_COMPILE);
+    modelList = glGenLists(1);
+    glNewList (modelList, GL_COMPILE);
 
     glColor3f(1.0,0,0);
Index: branches/new_class_id/src/world_entities/terrain.h
===================================================================
--- branches/new_class_id/src/world_entities/terrain.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/terrain.h	(revision 9709)
@@ -12,5 +12,4 @@
 
 #include "world_entity.h"
-#include "vector.h"
 
 // FORWARD DECLARATION
@@ -26,4 +25,5 @@
 class Terrain : public WorldEntity
 {
+  NewObjectListDeclaration(Terrain);
 
  public:
@@ -52,5 +52,5 @@
  private:
    Model*              vegetation;
-   int                 objectList;
+   int                 modelList;
 
    HeightMap*          heightMap;
Index: branches/new_class_id/src/world_entities/test_entity.cc
===================================================================
--- branches/new_class_id/src/world_entities/test_entity.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/test_entity.cc	(revision 9709)
@@ -35,14 +35,15 @@
 
 
-
-CREATE_FACTORY(TestEntity, CL_TEST_ENTITY);
+#include "class_id.h"
+NewObjectListDefinition(TestEntity);
+CREATE_FACTORY(TestEntity);
 
 #include "script_class.h"
-CREATE_SCRIPTABLE_CLASS(TestEntity, CL_TEST_ENTITY,
+CREATE_SCRIPTABLE_CLASS(TestEntity, TestEntity::classID(),
                             addMethod("setAbsCoor", ExecutorLua3<PNode,float,float,float>(&PNode::setAbsCoor))
                             ->addMethod("getAbsCoorX", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorX))
                             ->addMethod("getAbsCoorY", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorY))
                             ->addMethod("getAbsCoorZ", ExecutorLua0ret<PNode, float>(&PNode::getAbsCoorZ))
-                            
+
                        );
 
@@ -75,5 +76,5 @@
 void TestEntity::init()
 {
-  this->setClassID(CL_TEST_ENTITY, "TestEntity");
+  this->registerObject(this, TestEntity::_objectList);
   this->toList(OM_GROUP_00);
 
Index: branches/new_class_id/src/world_entities/test_entity.h
===================================================================
--- branches/new_class_id/src/world_entities/test_entity.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/test_entity.h	(revision 9709)
@@ -15,4 +15,5 @@
 class TestEntity : public WorldEntity, public PhysicsInterface
 {
+  NewObjectListDeclaration(TestEntity);
  public:
   TestEntity ();
Index: branches/new_class_id/src/world_entities/weapons/aim.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/aim.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/aim.cc	(revision 9709)
@@ -29,4 +29,5 @@
 
 
+NewObjectListDefinition(Aim);
 
 /**
@@ -59,5 +60,5 @@
 void Aim::init()
 {
-  this->setClassID(CL_CROSSHAIR, "Aim");
+  this->registerObject(this, Aim::_objectList);
   this->setName("Aim");
 
@@ -107,6 +108,6 @@
   ObjectManager::EntityList::iterator entity;
   //printf("%d\n", this->targetGroup);
-  for (entity = State::getObjectManager()->getObjectList(this->targetGroup).begin();
-       entity != State::getObjectManager()->getObjectList(this->targetGroup).end();
+  for (entity = State::getObjectManager()->getEntityList(this->targetGroup).begin();
+       entity != State::getObjectManager()->getEntityList(this->targetGroup).end();
        entity ++)
   {
Index: branches/new_class_id/src/world_entities/weapons/aim.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/aim.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/aim.h	(revision 9709)
@@ -19,4 +19,5 @@
 template<class T> class tAnimation;
 
+
 //! An Aim for zooming in on Targets.
 /**
@@ -28,4 +29,5 @@
 class Aim : public PNode, public Element2D
 {
+  NewObjectListDeclaration(Aim);
 
 public:
Index: branches/new_class_id/src/world_entities/weapons/aiming_system.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/aiming_system.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/aiming_system.cc	(revision 9709)
@@ -30,4 +30,5 @@
 
 
+NewObjectListDefinition(AimingSystem);
 
 /**
@@ -55,5 +56,5 @@
 void AimingSystem::init()
 {
-  this->setClassID(CL_AIMING_SYSTEM, "AimingSystem");
+  this->registerObject(this, AimingSystem::_objectList);
   this->setName("AimingSystem");
 
@@ -63,5 +64,5 @@
   // registering default reactions:
   this->unsubscribeReaction(CREngine::CR_OBJECT_DAMAGE);
-  this->subscribeReaction(CREngine::CR_OBJECT_DAMAGE, CL_WORLD_ENTITY);
+  this->subscribeReaction(CREngine::CR_OBJECT_DAMAGE, WorldEntity::classID());
 
   this->range = 1000.0f;
Index: branches/new_class_id/src/world_entities/weapons/aiming_system.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/aiming_system.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/aiming_system.h	(revision 9709)
@@ -21,4 +21,5 @@
 class AimingSystem : public WorldEntity
 {
+  NewObjectListDeclaration(AimingSystem);
 
  public:
Index: branches/new_class_id/src/world_entities/weapons/aiming_turret.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/aiming_turret.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/aiming_turret.cc	(revision 9709)
@@ -27,6 +27,7 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(AimingTurret, CL_AIMING_TURRET);
-
+#include "class_id.h"
+NewObjectListDefinitionID(AimingTurret, CL_AIMING_TURRET);
+CREATE_FACTORY(AimingTurret);
 
 
@@ -64,5 +65,5 @@
 void AimingTurret::init()
 {
-  this->setClassID(CL_AIMING_TURRET, "AimingTurret");
+  this->registerObject(this, AimingTurret::_objectList);
 
   Animation3D* animation1 = this->getAnimation(WS_ACTIVATING, this);
@@ -86,5 +87,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_GUIDED_MISSILE);
+  this->setProjectileTypeC("GuidedMissile");
 
 
Index: branches/new_class_id/src/world_entities/weapons/aiming_turret.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/aiming_turret.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/aiming_turret.h	(revision 9709)
@@ -13,4 +13,6 @@
 class AimingTurret : public Weapon
 {
+  NewObjectListDeclaration(AimingTurret);
+
 public:
   AimingTurret ();
Index: branches/new_class_id/src/world_entities/weapons/boomerang_gun.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/boomerang_gun.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/boomerang_gun.cc	(revision 9709)
@@ -27,5 +27,7 @@
 #include "util/loading/factory.h"
 
-CREATE_FACTORY(BoomerangGun, CL_BOOMERANG_GUN);
+#include "class_id.h"
+NewObjectListDefinitionID(BoomerangGun, CL_BOOMERANG_GUN);
+CREATE_FACTORY(BoomerangGun);
 
 
@@ -61,5 +63,5 @@
 void BoomerangGun::init()
 {
-  this->setClassID(CL_BOOMERANG_GUN, "BoomerangGun");
+  this->registerObject(this, BoomerangGun::_objectList);
 
 
@@ -85,5 +87,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_TURRET);
-  this->setProjectileType(CL_BOOMERANG_PROJECTILE);
+  this->setProjectileTypeC("BoomerangProjectile");
 
   this->loadModel("models/guns/turret1.obj", 5.0);
Index: branches/new_class_id/src/world_entities/weapons/boomerang_gun.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/boomerang_gun.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/boomerang_gun.h	(revision 9709)
@@ -11,4 +11,5 @@
 class BoomerangGun : public Weapon
   {
+    NewObjectListDeclaration(BoomerangGun);
   public:
     BoomerangGun ();
Index: branches/new_class_id/src/world_entities/weapons/cannon.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/cannon.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/cannon.cc	(revision 9709)
@@ -32,10 +32,11 @@
 #include "animation3d.h"
 
-#include "fast_factory.h"
-
-
-
-
-CREATE_FACTORY(Cannon, CL_CANNON);
+#include "loading/fast_factory.h"
+
+
+
+#include "class_id.h"
+NewObjectListDefinitionID(Cannon, CL_CANNON);
+CREATE_FACTORY(Cannon);
 
 /**
@@ -69,5 +70,5 @@
 void Cannon::init()
 {
-  this->setClassID(CL_CANNON, "Cannon");
+  this->registerObject(this, Cannon::_objectList);
 
 //  this->model = (Model*)ResourceManager::getInstance()->load("models/guns/test_gun.obj", OBJ, RP_CAMPAIGN);
@@ -88,5 +89,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL | WTYPE_HEAVY);
-  this->setProjectileType(CL_BOMB);
+  this->setProjectileTypeC("Bomb");
   this->prepareProjectiles(5);
 
Index: branches/new_class_id/src/world_entities/weapons/cannon.h
===================================================================
--- branches/new_class_id/src/world_entities/weapons/cannon.h	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/cannon.h	(revision 9709)
@@ -12,4 +12,5 @@
 class Cannon : public Weapon
   {
+    NewObjectListDeclaration(Cannon);
   public:
     Cannon ();
Index: branches/new_class_id/src/world_entities/weapons/fps_sniper_rifle.cc
===================================================================
--- branches/new_class_id/src/world_entities/weapons/fps_sniper_rifle.cc	(revision 9707)
+++ branches/new_class_id/src/world_entities/weapons/fps_sniper_rifle.cc	(revision 9709)
@@ -29,5 +29,5 @@
 
 
-#include "fast_factory.h"
+#include "loading/fast_factory.h"
 
 #include "fps_sniper_rifle.h"
@@ -39,5 +39,7 @@
 
 
-CREATE_FACTORY(FPSSniperRifle, CL_FPS_SNIPER_RIFLE);
+#include "class_id.h"
+NewObjectListDefinitionID(FPSSniperRifle, CL_FPS_SNIPER_RIFLE);
+CREATE_FACTORY(FPSSniperRifle);
 
 /**
@@ -76,5 +78,5 @@
 void FPSSniperRifle::init()
 {
-  this->setClassID(CL_FPS_SNIPER_RIFLE, "FPSSniperRifle");
+  this->registerObject(this, FPSSniperRifle::_objectList);
 
   this->loadModel("models/guns/fps_sniper_rifle.obj", 0.2);
@@ -98,5 +100,5 @@
 
   this->setCapability(WTYPE_ALLDIRS | WTYPE_DIRECTIONAL);
-  this->setProjectileType(CL_LASER);
+  this->setProjectileTypeC("Laser");
   this->prepareProjectiles(20);
 
